# 1 "checksum.c"
# 36

# 1 "/usr/include/sys/types.h"
# 9

# 1 "/usr/include/sys/stdsyms.h"
# 149

# 10 "/usr/include/sys/types.h"





     typedef long dev_t;




     typedef unsigned long ino_t;




     typedef unsigned short mode_t;




     typedef short nlink_t;




     typedef long off_t;




     typedef long pid_t;




     typedef long gid_t;




     typedef long uid_t;




     typedef long time_t;




     typedef unsigned int size_t;




      typedef int ssize_t;




     typedef unsigned short __site_t;




     typedef unsigned short __cnode_t;
# 224

# 82
     typedef unsigned long clock_t;




      typedef long key_t;


   typedef unsigned short __ushort;

   typedef long	__daddr_t;
   typedef char *__caddr_t;
   typedef long __swblk_t;
# 243

# 102
     typedef __caddr_t		caddr_t;




   typedef unsigned char	u_char;
   typedef unsigned short	u_short;
   typedef unsigned int		u_int;
   typedef unsigned long	u_long;
   typedef unsigned int		uint;
   typedef unsigned short	ushort;
   typedef unsigned char  ubit8;
   typedef unsigned short ubit16;
   typedef unsigned long  ubit32;
   typedef char           sbit8;
   typedef short          sbit16;
   typedef long           sbit32;

   typedef __swblk_t		swblk_t;
   typedef __daddr_t		daddr_t;
   typedef __site_t		site_t;
   typedef __cnode_t		cnode_t;

   typedef long			paddr_t;
   typedef short		cnt_t;
   typedef unsigned int		space_t;
   typedef unsigned int    	prot_t;
   typedef unsigned long        cdno_t;
   typedef unsigned short	use_t;

   typedef struct _physadr { int r[1]; } *physadr;
   typedef struct _quad { long val[2]; } quad;

   typedef char spu_t;
# 284

# 165
     typedef short cpu_t;
     typedef struct label_t {
	int	lbl_rp;
       	int	lbl_sp;
       	int	lbl_s[17];
       	int	lbl_ss[1];
	double	lbl_sf[4];
     } label_t;



   typedef char *dm_message;




      typedef long	aid_t;
# 330

# 190
   typedef pid_t		sid_t;
# 339

# 238
     typedef long fd_mask;
# 387

# 246
     typedef struct fd_set {
       fd_mask fds_bits[(((2048)+(((sizeof(fd_mask) * 8))-1))/((sizeof(fd_mask) * 8)))];
     } fd_set;
# 279

# 37 "checksum.c"

# 1 "/usr/include/netinet/in.h"
# 68
struct in_addr {
	u_long s_addr;
};
# 125
struct sockaddr_in {
	short	sin_family;
	u_short	sin_port;
	struct	in_addr sin_addr;
	char	sin_zero[8];
};
# 160
struct ip_mreq {
	struct in_addr	imr_multiaddr;
	struct in_addr	imr_interface;
};
# 174

# 38 "checksum.c"
# 48

# 47
unsigned short  sumArray[] = { 0x2146, 0x311a, 0x75b1, 0x2a75, 0x4f64,
			       0x7453, 0x13fc, 0x33a4, 0x4e05, 0x6dad,
			       0x0810, 0x2271, 0x3cd3, 0x6708, 0x016b };

extern int	debuglev;

int
checkSum(unsigned char *buf, int byteCount)
{
   unsigned int		sum = 0x2113;
   unsigned char	*cp;
   int			index = 0;
   unsigned short	val;
   unsigned char	byte1, byte2;

   cp = buf;
   while( byteCount >= 2 ) {

      byte1 = *cp++;
      byte2 = *cp++;
      byteCount -= 2;

      val = (byte1<<sizeof(char)) + byte2;
      sum += (val ^ sumArray[index%sizeof(sumArray)]);
   }




   if ( byteCount > 0 ) {

      byte1 = *cp;
      byte2 = 0;

      val = (byte1<<sizeof(char)) + byte2;
      sum += (val ^ sumArray[index%sizeof(sumArray)]);
   }

   return sum;
}



























































