/*
 * $Id: StrCase.h,v 1.1 1998/06/24 01:29:07 lang Exp $
 *
 * Copyright (c) 1994 HAL Computer Systems International, Ltd.
 * 
 *          HAL COMPUTER SYSTEMS INTERNATIONAL, LTD.
 *                  1315 Dell Avenue
 *                  Campbell, CA  95008
 *
 * Author: Greg Hilton
 * Contributors: Tom Lang, Frank Bieser, and others
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * http://www.gnu.org/copyleft/gpl.html
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _StrCase_h_
#define _StrCase_h_

#if defined(SYSV) || defined(__hal) || defined(AIX)
# if defined SOLARIS || defined HPUX || defined LINUX || defined UXP
#  include <string.h>
# elif defined SGI
#  include <string.h>
# else
#  ifdef AIX
#   include <string.h>
#  endif
   extern "C" int strncasecmp(char*,char*,int);
   extern "C" int strcasecmp(char*,char*);
# endif
#else
# include <strings.h>
#endif

extern char     *StrCaseStr(char*, char*);

#endif // _StrCase_h_
